'*** Programa AM4 -  Emparrillado Plano -  Cargas normales -  QuickBASIC 4.0 *
'*** Autor:  Francisco Morn Cabr - Avenida de Amrica, 51 - 28.002  Madrid *


DEFINT I-N: OPTION BASE 1
OPEN "DATOS" FOR INPUT AS #1
OPEN "RES" FOR OUTPUT AS #2

Herc% = 0                  '*** Pantalla CGA. Para Hrcules, poner Herc% = 1
IF Herc% = 1 THEN npixx = 719: npixy = 347: ncarx = 9: ncary = 14: rel = 1.5
IF Herc% = 0 THEN npixx = 639: npixy = 199: ncarx = 8: ncary = 8: rel = 2.4

GOSUB Dat.Grales
GOSUB Abscisas
GOSUB Ordenadas
GOSUB Barras.Tipo
GOSUB Escalas
GOSUB Mat.Rigidez
GOSUB Numer.Nudos
GOSUB Carg.Nudos
GOSUB Carg.Barras
GOSUB Apoyos
'GOSUB Print.Matriz
GOSUB Okey
GOSUB Sol.Sistema
GOSUB Graba.Resul

SCREEN 0: END


Dat.Grales:                           '*** Lectura del ttulo, datos grales
  INPUT #1, tit$                      '*** y dimensionamiento de las matrices
  er$ = "TITULO": GOSUB Fin.Grupo
  INPUT #1, Nnu, Nba, Ndi, Nhi, G, E  '*** N.Nudos, barr, difmax, hipt, G, E
  er$ = "DATOS GRALES": GOSUB Fin.Grupo
  Nec = 3 * Nnu: Nsb = 3 * (Ndi + 1)       '*** Nm. ecuac. y ancho semibanda
  DIM x(Nnu), y(Nnu), ni(Nba), nj(Nba), it(Nba) '** Coord, incidencias barras
  DIM R(Nec, Nsb), F(Nec, Nhi)             '*** Matrices de Rigidez y Cargas
  RETURN


Barras.Tipo:                    '*** Lectura Inerc. flex. y tors. barras tipo
  INPUT #1, Nbt: DIM Ifle!(Nbt), Jtor!(Nbt)
  FOR i = 1 TO Nbt
    INPUT #1, Ifle!(i), Jtor!(i)
  NEXT i: er$ = "BARRAS TIPO": GOSUB Fin.Grupo
  RETURN


Mat.Rigidez:                     '*** Lectura de datos barras, comprobacin,
  FOR iba = 1 TO Nba             '*** dibujo croquis y formac.matriz rigidez
    INPUT #1, i, j, ntip               '*** Incidencia y tipo de la barra
    IF ntip > Nbt OR i > Nnu OR j > Nnu OR i >= j OR j - i > Ndi THEN
       er$ = "BARRA " + STR$ (i) + " - " + STR$ (j): GOSUB Mensaje: END
    END IF

    xi = (x(i) - xmin) * esx: yi = npixy - (y(i) - ymin) * esy
    xj = (x(j) - xmin) * esx: yj = npixy - (y(j) - ymin) * esy
    LINE (xi, yi)-(xj, yj)

    ni(iba) = i: nj(iba) = j: it(iba) = ntip
    i1 = 3 * (i - 1) + 1: i2 = i1 + 1: i3 = i2 + 1      '*Filas modif.nudo i
    j1 = 3 * (j - 1) + 1: j2 = j1 + 1: j3 = j2 + 1      '*Filas modif.nudo j
    jd = 3 * (j - i)                                    '*Distancia i - j
    dx = x(j) - x(i): dy = y(j) - y(i)
    rl = SQR(dx * dx + dy * dy): cosa = dx / rl: sena = dy / rl
    GJL = G * Jtor!(ntip) / rl                      '*** Eltos. para clculo
    EIL = 2 * E * Ifle!(ntip) / rl                  '*** de coefs. de matriz
    EI1 = 6 * E * Ifle!(ntip) / rl / rl             '*** de rigidez
    EI2 = 12 * E * Ifle!(ntip) / rl / rl / rl
    t = GJL * cosa * cosa + 2 * EIL * sena * sena
    R(i1, 1) = R(i1, 1) + t: R(j1, 1) = R(j1, 1) + t   '*** Aportacin de la
    R(i1, 1 + jd) = EIL * sena * sena - GJL * cosa * cosa  'barra a la matriz
    t = (GJL - 2 * EIL) * sena * cosa                      'de rigidez
    R(i1, 2) = R(i1, 2) + t: R(j1, 2) = R(j1, 2) + t
    t = -(GJL + EIL) * sena * cosa
    R(i1, 2 + jd) = t: R(i2, jd) = t
    t = EI1 * sena
    R(i1, 3) = R(i1, 3) + t: R(j1, 3) = R(j1, 3) - t
    R(i1, 3 + jd) = -t: R(i3, -1 + jd) = t
    t = GJL * sena * sena + 2 * EIL * cosa * cosa
    R(i2, 1) = R(i2, 1) + t: R(j2, 1) = R(j2, 1) + t
    R(i2, 1 + jd) = EIL * cosa * cosa - GJL * sena * sena
    t = EI1 * cosa
    R(i2, 2) = R(i2, 2) - t: R(j2, 2) = R(j2, 2) + t
    R(i2, 2 + jd) = t: R(i3, jd) = -t
    t = EI2
    R(i3, 1) = R(i3, 1) + t: R(j3, 1) = R(j3, 1) + t
    R(i3, 1 + jd) = -t
  NEXT iba: er$ = "DEF. DE BARRAS": GOSUB Fin.Grupo
  RETURN


Carg.Nudos:                            '*** Lectura cargas nudos y formacin
  FOR ih = 1 TO Nhi                    '*** de trminos independientes
      INPUT #1, Nnc                       '*** Nm. de nudos con cargas
      FOR inu = 1 TO Nnc
          INPUT #1, nn, Mx!, My!, Fz      '*** Nudo cargado, momtos. y fuerza
          i = 3 * (nn - 1) + 1
          F(i, ih) = Mx!
          F(i + 1, ih) = My!
          F(i + 2, ih) = Fz
      NEXT inu
  NEXT ih: er$ = "CARGAS EN NUDOS": GOSUB Fin.Grupo
  RETURN


Carg.Barras:                        '*** Lectura cargas barras y modificacin
FOR ih = 1 TO Nhi                   '*** de trminos independientes
   INPUT #1, Nbc                         '*** Nm. barras con cargas
   IF Nbc > 0 THEN
      FOR iba = 1 TO Nba
         INPUT #1, Nca                   '*** Nm. cargas en la barra
         IF Nca > 0 THEN
           tor.i = 0: cte.i = 0: fle.i = 0       '*** Esfzos empotr. nudo i
           tor.j = 0: cte.j = 0: fle.j = 0       '*** Esfzos empotr. nudo j
           i = ni(iba): j = nj(iba): ntip = it(iba)
           ifi = 3 * (i - 1) + 1: jfi = 3 * (j - 1) + 1    '*** Filas matriz
           dx = x(j) - x(i): dy = y(j) - y(i)
           rl = SQR(dx * dx + dy * dy): cosa = dx / rl: sena = dy / rl
           GOSUB Esfu.Empotr                   '*** Clculo esfuerzos empotr.
           F(ifi, ih) = F(ifi, ih) - tor.i * cosa + fle.i * sena
           F(jfi, ih) = F(jfi, ih) + tor.j * cosa + fle.j * sena
           F(ifi + 1, ih) = F(ifi + 1, ih) - tor.i * sena - fle.i * cosa
           F(jfi + 1, ih) = F(jfi + 1, ih) + tor.j * sena - fle.j * cosa
           F(ifi + 2, ih) = F(ifi + 2, ih) + cte.i
           F(jfi + 2, ih) = F(jfi + 2, ih) - cte.j
         END IF
      NEXT iba
   END IF
NEXT ih: er$ = "CARGAS EN BARRAS": GOSUB Fin.Grupo
RETURN


Graba.Resul:                           '*** Clculo y grabacin de resultados
  PRINT : PRINT "GRABANDO RESULTADOS"
  OPEN "DATOS" FOR INPUT AS #1      '*** Se vuelven a leer datos para clculo
  INPUT #1, tit$: GOSUB Fin.Grupo   '*** de los esf. de empotr. en barras
  INPUT #1, Nnu, Nba, Ndi, Nhi, G, E: GOSUB Fin.Grupo
  FOR i = 1 TO Nnu: INPUT #1, a: NEXT i: GOSUB Fin.Grupo
  FOR i = 1 TO Nnu: INPUT #1, a: NEXT i: GOSUB Fin.Grupo
  INPUT #1, Nbt
  FOR i = 1 TO Nbt: INPUT #1, a, a: NEXT i: GOSUB Fin.Grupo
  FOR i = 1 TO Nba: INPUT #1, j, j, j: NEXT i: GOSUB Fin.Grupo
  FOR i = 1 TO Nhi: INPUT #1, Nnc:
    FOR j = 1 TO Nnc: INPUT #1, k, a, a, a: NEXT j
  NEXT i: GOSUB Fin.Grupo

  c$ = "#### #####.##### #####.##### #####.#####"
  a$ = " #######.###": b$ = " ######.###"
  d$ = "###  ###" + a$ + a$ + b$ + a$ + a$ + b$
  FOR ih = 1 TO Nhi
    PRINT #2, : PRINT #2, : PRINT #2, TAB(10); tit$
    PRINT #2, : PRINT #2, TAB(20); "HIPOTESIS NUM."; ih
    PRINT #2, : PRINT #2, TAB(16); "DESPLAZAMIENTOS DE NUDOS"
    PRINT #2, : PRINT #2, " Nudo     Giro  x     Giro  y    Despl.z"
    PRINT #2, : i = 1
    FOR inu = 1 TO Nnu
      PRINT #2, USING c$; inu, F(i, ih), F(i + 1, ih), F(i + 2, ih)
      i = i + 3
    NEXT inu
    PRINT #2, : PRINT #2,
    PRINT #2, TAB(30); "ESFUERZOS EN BARRAS": PRINT #2,
    PRINT #2, "  i    j     Torsor i    Flect. i    Corte.i";
    PRINT #2, "    Torsor j    Flect. j    Corte.j": PRINT #2,
    INPUT #1, Nbc
    FOR iba = 1 TO Nba
        tor.i = 0: cte.i = 0: fle.i = 0                '*** Esf. empotr. nudo i
        tor.j = 0: cte.j = 0: fle.j = 0                '*** Esf. empotr. nudo j
        i = ni(iba): j = nj(iba): ntip = it(iba)
        ifi = 3 * (i - 1) + 1: jfi = 3 * (j - 1) + 1  '*** Filas nudos i y j
        dx = x(j) - x(i): dy = y(j) - y(i)
        rl = SQR(dx * dx + dy * dy): cosa = dx / rl: sena = dy / rl
        GJL = G * Jtor!(ntip) / rl                    '*** Coefs. de rigidez
        EIL = 2 * E * Ifle!(ntip) / rl
        EI1 = 6 * E * Ifle!(ntip) / rl / rl
        EI2 = 12 * E * Ifle!(ntip) / rl / rl / rl
        xi = F(ifi, ih): xj = F(jfi, ih)
        yi = F(ifi + 1, ih): yj = F(jfi + 1, ih)
        z = F(jfi + 2, ih) - F(ifi + 2, ih)
        trh = GJL * ((xj - xi) * cosa + (yj - yi) * sena)   'Torsor hiperest.
        cth = ((xi + xj) * sena - (yi + yj) * cosa) * EI1 - z * EI2     'Cte.
        fih = ((2 * xi + xj) * sena - (2 * yi + yj) * cosa) * EIL - z * EI1
        fjh = ((2 * yj + yi) * cosa - (2 * xj + xi) * sena) * EIL + z * EI1
        IF Nbc > 0 THEN
          INPUT #1, Nca
          GOSUB Esfu.Empotr
        END IF
        tor.i = tor.i + trh: tor.j = tor.j + trh
        cte.i = -cte.i + cth: cte.j = cte.j - cth
        fle.i = -fle.i + fih: fle.j = fle.j + fjh
        PRINT #2, USING d$; i, j, tor.i, fle.i, cte.i, tor.j, fle.j, cte.j
    NEXT iba
  NEXT ih
  RETURN


Esfu.Empotr:                               '*** Clculo de esf. de empotr. en
   FOR ica = 1 TO Nca                      '*** una barra
       INPUT #1, P, a, b, itc
       IF itc = 1 THEN                            '*** Carga puntual
          aL = a / rl
          tor.i = 0                                  '*** Torsor i
          tor.j = 0                                  '*** Torsor j
          bL = (3 - 2 * aL) * aL * aL
          cte.i = cte.i + P * (1 - bL)               '*** Cortante i
          cte.j = cte.j - P * bL                     '*** Cortante j
          aL = 1 - aL
          fle.i = fle.i + P * aL * aL * a            '*** Momento i
          fle.j = fle.j - P * aL * a * a / rl        '*** Momento j
       ELSEIF itc = 2 THEN                        '*** Carga repartida
          c = a + b
          tor.i = 0                                        '*** Torsor i
          tor.j = 0                                        '*** Torsor j
          c2 = c * c: a2 = a * a
          ca3 = c2 * c - a2 * a
          ca4 = c2 * c2 - a2 * a2
          Pdl2 = P / 2 / rl / rl
          dif = ca4 / rl - 2 * ca3
          cte.i = cte.i + Pdl2 * (2 * b * rl * rl + dif)   '*** Cortante i
          cte.j = cte.j + Pdl2 * dif                       '*** Cortante j
          ca4 = ca4 * 3 / rl / rl
          fle.i = fle.i + P * (6 * (c2 - a2) + ca4 - 8 * ca3 / rl) / 12
          fle.j = fle.j + P * (ca4 - 4 * ca3 / rl) / 12    '*** Momento j
       ELSE
          er$ = "CARGA BARRA " + STR$ (i) + " - " + STR$ (j)
          GOSUB Mensaje: END
       END IF
   NEXT ica
   RETURN








