'*** Programa AM1 - Estruc. Reticular Plana cargas en plano - QuickBASIC 4.0 *
'*** Autor:  Francisco Morn Cabr - Avenida de Amrica, 51 - 28.002  Madrid *


DEFINT I-N: OPTION BASE 1
OPEN "DATOS" FOR INPUT AS #1
OPEN "RES" FOR OUTPUT AS #2
pi = 3.14159265#

Herc% = 0                  '*** Pantalla CGA. Para Hrcules, poner Herc% = 1
IF Herc% = 1 THEN npixx = 719: npixy = 347: ncarx = 9: ncary = 14: rel = 1.5
IF Herc% = 0 THEN npixx = 639: npixy = 199: ncarx = 8: ncary = 8: rel = 2.4

GOSUB Dat.Grales
GOSUB Abscisas
GOSUB Ordenadas
GOSUB Barras.Tipo
GOSUB Escalas
GOSUB Mat.Rigidez
GOSUB Numer.Nudos
GOSUB Carg.Nudos
GOSUB Carg.Barras
GOSUB Apoyos
'GOSUB Print.Matriz
GOSUB OKey
GOSUB Sol.Sistema
GOSUB Graba.Resul

SCREEN 0: END


Dat.Grales:                           '*** Lectura del ttulo, datos grales
  INPUT #1, tit$                      '*** y dimensionamiento de las matrices
  er$ = "TITULO": GOSUB Fin.Grupo
  INPUT #1, Nnu, Nba, Ndi, Nhi, E     '** N.nudos, barr, difmax, hipt, Young
  er$ = "DATOS GRALES": GOSUB Fin.Grupo
  Nec = 3 * Nnu: Nsb = 3 * (Ndi + 1)     '*** Nm. ecuac., ancho de semibanda
  DIM x(Nnu), y(Nnu), ni(Nba), nj(Nba), it(Nba) '** Coord, incidencias barras
  DIM R(Nec, Nsb), F(Nec, Nhi)           '*** Matrices de Rigidez y de Cargas
  RETURN


Abscisas:                           '*** Lectura abscisas y clculo max y min
  xmax = -100: xmin = 100
  FOR i = 1 TO Nnu
    INPUT #1, x(i)
    IF xmax < x(i) THEN xmax = x(i)
    IF xmin > x(i) THEN xmin = x(i)
  NEXT i: er$ = "ABSCISAS": GOSUB Fin.Grupo
  RETURN


Ordenadas:                         '*** Lectura ordenadas y clculo max y min
  ymax = -100: ymin = 100
  FOR i = 1 TO Nnu
    INPUT #1, y(i)
    IF ymax < y(i) THEN ymax = y(i)
    IF ymin > y(i) THEN ymin = y(i)
  NEXT i: er$ = "ORDENADAS": GOSUB Fin.Grupo
  RETURN


Barras.Tipo:                        '*** Lectura Inercias y Areas barras tipo
  INPUT #1, Nbt: DIM Iner!(Nbt), Area(Nbt)
  FOR i = 1 TO Nbt
    INPUT #1, Iner!(i), Area(i)
  NEXT i: er$ = "BARRAS TIPO": GOSUB Fin.Grupo
  RETURN


Escalas:                           '*** Clculo de las escalas del croquis
  CLS : SCREEN 2 + Herc%
  IF xmax = xmin THEN xmax = xmin + (ymax - ymin) / 10
  IF ymax = ymin THEN ymax = ymin + (xmax - xmin) / 10
  esx = npixx / (xmax - xmin): esy = npixy / (ymax - ymin)
  IF esx > rel * esy THEN esx = rel * esy ELSE esy = esx / rel
  RETURN


Mat.Rigidez:                      '*** Lectura de datos barras, comprobacin,
  FOR iba = 1 TO Nba              '*** dibujo croquis y formac.matriz rigidez
    INPUT #1, i, j, ntip               '*** Incidencia y tipo de la barra
    IF ntip > Nbt OR i > Nnu OR j > Nnu OR i >= j OR j - i > Ndi THEN
       er$ = "BARRA " + STR$ (i) + " - " + STR$ (j): GOSUB Mensaje: END
    END IF

    xi = (x(i) - xmin) * esx: yi = npixy - (y(i) - ymin) * esy
    xj = (x(j) - xmin) * esx: yj = npixy - (y(j) - ymin) * esy
    LINE (xi, yi)-(xj, yj)

    ni(iba) = i: nj(iba) = j: it(iba) = ntip
    i1 = 3 * (i - 1) + 1: i2 = i1 + 1: i3 = i2 + 1      '* Filas modif.nudo i
    j1 = 3 * (j - 1) + 1: j2 = j1 + 1: j3 = j2 + 1      '* Filas modif.nudo j
    jd = 3 * (j - i)                                    '* Distancia i - j
    dx = x(i) - x(j): dy = y(i) - y(j)
    rl = SQR(dx * dx + dy * dy): cosa = dx / rl: sena = dy / rl
    EAL = E * Area(ntip) / rl                       '*** Eltos. para clculo
    EIL = 2 * E * Iner!(ntip) / rl                  '*** de coefs. de matriz
    EI1 = 6 * E * Iner!(ntip) / rl / rl             '*** de rigidez
    EI2 = 12 * E * Iner!(ntip) / rl / rl / rl
    t = EAL * cosa * cosa + EI2 * sena * sena
    R(i1, 1) = R(i1, 1) + t: R(j1, 1) = R(j1, 1) + t    '* Aportacin de la
    R(i1, 1 + jd) = -t                                  '* barra a la matriz
    t = (EAL - EI2) * sena * cosa                       '* de rigidez
    R(i1, 2) = R(i1, 2) + t: R(j1, 2) = R(j1, 2) + t
    R(i1, 2 + jd) = -t: R(i2, jd) = -t
    t = EI1 * sena
    R(i1, 3) = R(i1, 3) - t: R(j1, 3) = R(j1, 3) + t
    R(i1, 3 + jd) = -t: R(i3, -1 + jd) = t
    t = EAL * sena * sena + EI2 * cosa * cosa
    R(i2, 1) = R(i2, 1) + t: R(j2, 1) = R(j2, 1) + t
    R(i2, 1 + jd) = -t
    t = EI1 * cosa
    R(i2, 2) = R(i2, 2) + t: R(j2, 2) = R(j2, 2) - t
    R(i2, 2 + jd) = t: R(i3, jd) = -t
    t = 2 * EIL
    R(i3, 1) = R(i3, 1) + t: R(j3, 1) = R(j3, 1) + t
    R(i3, 1 + jd) = t / 2
  NEXT iba: er$ = "DEF. DE BARRAS": GOSUB Fin.Grupo
  RETURN


Numer.Nudos:                        '*** Numeracin de los nudos del croquis
  esx = esx / ncarx: esy = esy / ncary
  FOR i = 1 TO Nnu
    nfil = 25 - INT((y(i) - ymin) * esy)
    ncol = INT((x(i) - xmin) * esx)
    IF nfil < 1 THEN nfil = 1
    IF ncol < 1 THEN ncol = 1
    IF ncol > 77 THEN ncol = 77
    LOCATE nfil, ncol: PRINT i;
  NEXT i
  RETURN


Carg.Nudos:                            '*** Lectura cargas nudos y formacin
  FOR ih = 1 TO Nhi                    '*** de trminos independientes
      INPUT #1, Nnc                      '*** Nm. de nudos con cargas
      FOR inu = 1 TO Nnc
          INPUT #1, nn, Fx, Fy, M!       '*** Nudo cargado, fuerzas y momento
          i = 3 * (nn - 1) + 1
          F(i, ih) = Fx
          F(i + 1, ih) = Fy
          F(i + 2, ih) = M!
      NEXT inu
  NEXT ih: er$ = "CARGAS EN NUDOS": GOSUB Fin.Grupo
  RETURN


Carg.Barras:                        '*** Lectura cargas barras y modificacin
  FOR ih = 1 TO Nhi                 '*** de trminos independientes
    INPUT #1, Nbc                      '*** Nm. barras con cargas
    IF Nbc > 0 THEN
      FOR iba = 1 TO Nba
         INPUT #1, Nca                 '*** Nm. cargas en la barra
         IF Nca > 0 THEN
           ax.i = 0: ct.i = 0: fl.i = 0          '*** Esfzos empotr. nudo i
           ax.j = 0: ct.j = 0: fl.j = 0          '*** Esfzos empotr. nudo j
           i = ni(iba): j = nj(iba): ntip = it(iba)
           ifi = 3 * (i - 1) + 1: jfi = 3 * (j - 1) + 1    '*** Filas matriz
           dx = x(i) - x(j): dy = y(i) - y(j)
           rl = SQR(dx * dx + dy * dy): cosa = dx / rl: sena = dy / rl
           GOSUB Esfu.Empotr                  '*** Clculo esfuerzos empotr.
           F(ifi, ih) = F(ifi, ih) - ax.i * cosa + ct.i * sena
           F(jfi, ih) = F(jfi, ih) + ax.j * cosa - ct.j * sena
           F(ifi + 1, ih) = F(ifi + 1, ih) - ax.i * sena - ct.i * cosa
           F(jfi + 1, ih) = F(jfi + 1, ih) + ax.j * sena + ct.j * cosa
           F(ifi + 2, ih) = F(ifi + 2, ih) - fl.i
           F(jfi + 2, ih) = F(jfi + 2, ih) - fl.j
         END IF
      NEXT iba
    END IF
  NEXT ih: er$ = "CARGAS EN BARRAS": GOSUB Fin.Grupo
RETURN


Apoyos:                               '*** Lectura def. apoyos y modificacin
  INPUT #1, Nap                       '*** de la matriz de rigidez
  FOR iap = 1 TO Nap               '*** Nm. de apoyos
     INPUT #1, na, cx, cy, cz      '*** Nudo apoyo y coef. coacc. o elsticos
     i = 3 * (na - 1) + 1: j = i + 1: k = i + 2        '*** Filas a modificar
     IF cx <> 1 THEN
        IF cx = 0 THEN R(i, 1) = 1E+20 ELSE R(i, 1) = R(i, 1) + cx
     END IF
     IF cy <> 1 THEN
        IF cy = 0 THEN R(j, 1) = 1E+20 ELSE R(j, 1) = R(j, 1) + cy
     END IF
     IF cz <> 1 THEN
        IF cz = 0 THEN R(k, 1) = 1E+20 ELSE R(k, 1) = R(k, 1) + cz
     END IF
  NEXT iap: er$ = "DEFINICION APOYOS": GOSUB Fin.Grupo: CLOSE #1
  RETURN


Print.Matriz:                       '*** Impresin por filas de las matrices
  FOR i = 1 TO Nec                  '*** de rigidez y de terminos independtes
      FOR j = 1 TO Nsb              '*** para pruebas del programa
          PRINT #2, R(i, j);
      NEXT j
      FOR j = 1 TO Nhi
          PRINT #2, F(i, j);
      NEXT j: PRINT #2, : IF (i \ 3) * 3 = i THEN PRINT #2,
  NEXT i
  RETURN


OKey:                             '*** Conformidad del usuario con el croquis
  LOCATE 1, 59: PRINT "Desea seguir? (s/n)": k$ = INKEY$
  WHILE k$ = "": k$ = INKEY$: WEND
  IF k$ = "n" OR k$ = "N" THEN er$ = "CROQUIS": GOSUB Mensaje: END
  RETURN


Sol.Sistema:                      '*** Resolucin del sistema de ecuaciones
   CLS : PRINT "SOLUCION SISTEMA. NUDOS TRATADOS:"
   FOR i = 1 TO Nec - 1         '*** Triangulacin. Fila i se resta de sgtes
   IF ((i + 1) \ 3) * 3 = i + 1 THEN PRINT USING "####"; (i + 1) \ 3;
       FOR j = 2 TO Nsb
           nfi = i + j - 1                '*** Fila a la que se resta la i
           IF nfi <= Nec AND R(i, j) <> 0 THEN
              fac = R(i, j) / R(i, 1)     '*** Factor por que se mult. fila i
              k = 1
              FOR l = j TO Nsb
                  R(nfi, k) = R(nfi, k) - fac * R(i, l)
                  k = k + 1
              NEXT l
              FOR k = 1 TO Nhi
                  F(nfi, k) = F(nfi, k) - fac * F(i, k)
              NEXT k
           END IF
       NEXT j
   NEXT i
   FOR i = Nec TO 1 STEP -1            '*** Sustitucin hacia atrs
       FOR k = 1 TO Nhi
           sum = 0
           FOR j = 2 TO Nsb
               nfi = i + j - 1
               IF nfi <= Nec THEN sum = sum + R(i, j) * F(nfi, k)
           NEXT j
           F(i, k) = (F(i, k) - sum) / R(i, 1)
       NEXT k
   NEXT i
  RETURN


Graba.Resul:                        '*** Clculo y grabacin de resultados
  PRINT : PRINT "GRABANDO RESULTADOS"
  OPEN "DATOS" FOR INPUT AS #1      '*** Se vuelven a leer datos para clculo
  INPUT #1, tit$: GOSUB Fin.Grupo   '*** de los esf. de empotr. en barras
  INPUT #1, Nnu, Nba, Ndi, Nhi, E: GOSUB Fin.Grupo
  FOR i = 1 TO Nnu: INPUT #1, a: NEXT i: GOSUB Fin.Grupo
  FOR i = 1 TO Nnu: INPUT #1, a: NEXT i: GOSUB Fin.Grupo
  INPUT #1, Nbt
  FOR i = 1 TO Nbt: INPUT #1, a, a: NEXT i: GOSUB Fin.Grupo
  FOR i = 1 TO Nba: INPUT #1, j, j, j: NEXT i: GOSUB Fin.Grupo
  FOR i = 1 TO Nhi: INPUT #1, Nnc:
    FOR j = 1 TO Nnc: INPUT #1, k, a, a, a: NEXT j
  NEXT i: GOSUB Fin.Grupo

  c$ = "#### #####.##### #####.##### #####.#####"
  a$ = " #######.###": b$ = " ######.###"
  d$ = "###  ###" + a$ + b$ + a$ + a$ + b$ + a$
  FOR ih = 1 TO Nhi
    PRINT #2, : PRINT #2, : PRINT #2, TAB(10); tit$
    PRINT #2, : PRINT #2, TAB(20); "HIPOTESIS NUM."; ih
    PRINT #2, : PRINT #2, TAB(16); "DESPLAZAMIENTOS DE NUDOS"
    PRINT #2, : PRINT #2, " Nudo    Direc. x    Direc. y     Giro"
    PRINT #2, : i = 1
    FOR inu = 1 TO Nnu
      PRINT #2, USING c$; inu, F(i, ih), F(i + 1, ih), F(i + 2, ih)
      i = i + 3
    NEXT inu
    PRINT #2, : PRINT #2,
    PRINT #2, TAB(30); "ESFUERZOS EN BARRAS": PRINT #2,
    PRINT #2, "  i    j      Axil i    Corte.i     Momto.i";
    PRINT #2, "      Axil j    Corte.j     Momto.j": PRINT #2,
    INPUT #1, Nbc
    FOR iba = 1 TO Nba
        ax.i = 0: ct.i = 0: fl.i = 0                '*** Esf. empotr. nudo i
        ax.j = 0: ct.j = 0: fl.j = 0                '*** Esf. empotr. nudo j
        i = ni(iba): j = nj(iba): ntip = it(iba)
        ifi = 3 * (i - 1) + 1: jfi = 3 * (j - 1) + 1  '*** Filas nudos i y j
        dx = x(i) - x(j): dy = y(i) - y(j)
        rl = SQR(dx * dx + dy * dy): cosa = dx / rl: sena = dy / rl
        EAL = E * Area(ntip) / rl                     '*** Coefs. de rigidez
        EIL = 2 * E * Iner!(ntip) / rl
        EI1 = 6 * E * Iner!(ntip) / rl / rl
        EI2 = 12 * E * Iner!(ntip) / rl / rl / rl
        x = F(jfi, ih) - F(ifi, ih)
        y = F(jfi + 1, ih) - F(ifi + 1, ih)
        z = F(jfi + 2, ih) + F(ifi + 2, ih)
        c = x * sena - y * cosa
        axh = -EAL * (x * cosa + y * sena)            '*** Axil hiperesttico
        cth = EI2 * c + EI1 * z                       '*** Cortante id.
        fih = (z + F(ifi + 2, ih)) * EIL + c * EI1    '*** Flector i id.
        fjh = (z + F(jfi + 2, ih)) * EIL + c * EI1    '*** Flector j id.
        IF Nbc > 0 THEN
          INPUT #1, Nca
          GOSUB Esfu.Empotr
        END IF
        ax.i = ax.i + axh: ax.j = ax.j + axh
        ct.i = ct.i + cth: ct.j = ct.j + cth
        fl.i = fl.i + fih: fl.j = fl.j + fjh
        PRINT #2, USING d$; i, j, ax.i, ct.i, fl.i, ax.j, ct.j, fl.j
    NEXT iba
  NEXT ih
  RETURN


Esfu.Empotr:                         '*** Clculo de esf. de empotramiento en
   FOR ica = 1 TO Nca                '*** una barra
       INPUT #1, P, a, b, tseta, itc
       sent = SIN(tseta * pi / 180): cost = COS(tseta * pi / 180)
       Pn = P * (cost * sena - sent * cosa)         '*** Componente normal
       Pt = -P * (sent * sena + cost * cosa)        '*** Comp. tangencial
       IF itc = 1 THEN                           '*** Carga puntual
          aL = a / rl
          ax.i = ax.i + Pt * (1 - aL)               '*** Axil i
          ax.j = ax.j - Pt * aL                     '*** Axil j
          bL = (3 - 2 * aL) * aL * aL
          ct.i = ct.i + Pn * (1 - bL)               '*** Cortante i
          ct.j = ct.j - Pn * bL                     '*** Cortante j
          aL = 1 - aL
          fl.i = fl.i + Pn * aL * aL * a            '*** Momento i
          fl.j = fl.j - Pn * aL * a * a / rl        '*** Momento j
       ELSEIF itc = 2 THEN                       '*** Carga repartida
          c = a + b: amc = (a + c) / 2 / rl
          ax.i = ax.i + Pt * b * (1 - amc)                '*** Axil i
          ax.j = ax.j - Pt * b * amc                      '*** Axil j
          c2 = c * c: a2 = a * a
          ca3 = c2 * c - a2 * a
          ca4 = c2 * c2 - a2 * a2
          Pdl2 = Pn / 2 / rl / rl
          dif = ca4 / rl - 2 * ca3
          ct.i = ct.i + Pdl2 * (2 * b * rl * rl + dif)    '*** Cortante i
          ct.j = ct.j + Pdl2 * dif                        '*** Cortante j
          ca4 = ca4 * 3 / rl / rl
          fl.i = fl.i + Pn * (6 * (c2 - a2) + ca4 - 8 * ca3 / rl) / 12
          fl.j = fl.j + Pn * (ca4 - 4 * ca3 / rl) / 12    '*** Momento j
       ELSE
          er$ = "CARGA BARRA " + STR$ (i) + " - " + STR$ (j)
          GOSUB Mensaje: END
       END IF
   NEXT ica
   RETURN


Fin.Grupo:                            '*** Chequeo de final de grupo de datos
  INPUT #1, linb$: IF linb$ <> "" THEN GOSUB Mensaje: END   '*** L. en blanco
  INPUT #1, lint$                                           '*** L. de ttulo
  INPUT #1, linb$: IF linb$ <> "" THEN GOSUB Mensaje: END   '*** L. en blanco
  RETURN


Mensaje:                                   '*** Impresin de mensaje de error
  LOCATE 24, 30: PRINT "ERROR EN "; er$
  PRINT "PULSE CUALQUIER TECLA PARA TERMINAR"
  WHILE INKEY$ = "": WEND
  SCREEN 0
  RETURN






