'*** Programa AM2 - Estruc. Articul. Plana - Cargas Nudos  - QuickBASIC 4.0 *
'*** Autor: Francisco Morn Cabr - Avenida de Amrica, 51 - 28.002  Madrid *


DEFINT I-N: OPTION BASE 1
OPEN "DATOS" FOR INPUT AS #1
OPEN "RES" FOR OUTPUT AS #2

Herc% = 0                  '*** Pantalla CGA. Para Hrcules, poner Herc% = 1
IF Herc% = 1 THEN npixx = 719: npixz = 347: ncarx = 9: ncarz = 14: rel = 1.5
IF Herc% = 0 THEN npixx = 639: npixz = 199: ncarx = 8: ncarz = 8: rel = 2.4

GOSUB Dat.Grales
GOSUB Abscisas
GOSUB Cotas
GOSUB Barras.Tipo
GOSUB Escalas
GOSUB Mat.Rigidez
GOSUB Numer.Nudos
GOSUB Carg.Nudos
GOSUB Apoyos
'GOSUB Print.Matriz
GOSUB Okey
GOSUB Sol.Sistema
GOSUB Graba.Resul

SCREEN 0: END


Dat.Grales:                           '*** Lectura del ttulo, datos grales
  INPUT #1, tit$                      '*** y dimensionamiento de las matrices
  er$ = "TITULO": GOSUB Fin.Grupo
  INPUT #1, Nnu, Nba, Ndi, Nhi, E  '*** Nm.Nudos, barr, difmax, hipt, Young
  er$ = "DATOS GRALES": GOSUB Fin.Grupo
  Nec = 2 * Nnu: Nsb = 2 * (Ndi + 1)       '*** Nm. ecuac. y ancho semibanda
  DIM x(Nnu), z(Nnu), ni(Nba), nj(Nba), it(Nba)'** Coord, incidencias, tipos
  DIM R(Nec, Nsb), F(Nec, Nhi)             '*** Matrices de Rigidez y Cargas
  RETURN


Cotas:                             '*** Lectura cotas y clculo mx y mn
  zmax = -100: zmin = 100
  FOR i = 1 TO Nnu
    INPUT #1, z(i)
    IF zmax < z(i) THEN zmax = z(i)
    IF zmin > z(i) THEN zmin = z(i)
  NEXT i: er$ = "COTAS": GOSUB Fin.Grupo
  RETURN


Barras.Tipo:                      '*** Lectura de Areas de las barras tipo
  INPUT #1, Nbt: DIM Area(Nbt)
  FOR i = 1 TO Nbt
    INPUT #1, Area(i)
  NEXT i: er$ = "BARRAS TIPO": GOSUB Fin.Grupo
  RETURN


Escalas:                          '*** Clculo de las escalas del croquis
  CLS : SCREEN 2 + Herc%
  IF xmax = xmin THEN xmax = xmin + (zmax - zmin) / 10
  IF zmax = zmin THEN zmax = zmin + (xmax - xmin) / 10
  esx = npixx / (xmax - xmin): esz = npixz / (zmax - zmin)
  IF esx > rel * esz THEN esx = rel * esz ELSE esz = esx / rel
  RETURN


Mat.Rigidez:                     '*** Lectura de datos barras, comprobacin,
  FOR iba = 1 TO Nba             '*** dibujo croquis y formac.matriz rigidez
    INPUT #1, i, j, ntip               '*** Incidencia y tipo de la barra
    IF ntip > Nbt OR i > Nnu OR j > Nnu OR i >= j OR j - i > Ndi THEN
       er$ = "BARRA " + STR$ (i) + " - " + STR$ (j): GOSUB Mensaje: END
    END IF

    xi = (x(i) - xmin) * esx: zi = npixz - (z(i) - zmin) * esz
    xj = (x(j) - xmin) * esx: zj = npixz - (z(j) - zmin) * esz
    LINE (xi, zi)-(xj, zj)

    ni(iba) = i: nj(iba) = j: it(iba) = ntip
    i1 = 2 * (i - 1) + 1: i2 = i1 + 1                   '*Filas modif.nudo i
    j1 = 2 * (j - 1) + 1: j2 = j1 + 1                   '*Filas modif.nudo j
    jd = 2 * (j - i)                                    '*Distancia i - j
    dx = x(j) - x(i):  dz = z(j) - z(i)
    rl = SQR(dx * dx + dz * dz)                         '*Longitud barra
    cosa = dx / rl:  cosb = dz / rl                     '*Cosenos directores
    EAL = E * Area(ntip) / rl                       '*** Elto. para clculo
    T = EAL * cosa * cosa                           '*** de la matriz rigidez
    R(i1, 1) = R(i1, 1) + T: R(j1, 1) = R(j1, 1) + T   '*** Aportacin de la
    R(i1, 1 + jd) = -T                                 '*** barra a la matriz
    T = EAL * cosa * cosb                              '*** de rigidez
    R(i1, 2) = R(i1, 2) + T: R(j1, 2) = R(j1, 2) + T
    R(i1, 2 + jd) = -T: R(i2, jd) = -T
    T = EAL * cosb * cosb
    R(i2, 1) = R(i2, 1) + T: R(j2, 1) = R(j2, 1) + T
    R(i2, 1 + jd) = -T
  NEXT iba: er$ = "DEF. DE BARRAS": GOSUB Fin.Grupo
  RETURN


Numer.Nudos:                         '*** Numeracin de los nudos del croquis
  esx = esx / ncarx: esz = esz / ncarz
  FOR i = 1 TO Nnu
    nfil = 25 - INT((z(i) - zmin) * esz)
    ncol = INT((x(i) - xmin) * esx)
    IF nfil < 1 THEN nfil = 1
    IF ncol < 1 THEN ncol = 1
    IF ncol > 77 THEN ncol = 77
    LOCATE nfil, ncol: PRINT i;
  NEXT i
  RETURN


Carg.Nudos:                            '*** Lectura cargas nudos y formacin
  FOR ih = 1 TO Nhi                    '*** de trminos independientes
      INPUT #1, Nnc                       '*** Nm. de nudos con cargas
      FOR inu = 1 TO Nnc
          INPUT #1, nn, Fx, Fz           '*** Nudo cargado, componentes carga
          i = 2 * (nn - 1) + 1
          F(i, ih) = Fx
          F(i + 1, ih) = Fz
      NEXT inu
  NEXT ih: er$ = "CARGAS EN NUDOS": GOSUB Fin.Grupo
  RETURN


Apoyos:                               '*** Lectura def. apoyos y modificacin
  INPUT #1, Nap                       '*** de la matriz de rigidez
  FOR iap = 1 TO Nap               '*** Nm. de apoyos
     INPUT #1, na, cx, cz          '*** Nudo apoyo y coef. coacc. o elsticos
     i = 2 * (na - 1) + 1: j = i + 1                   '*** Filas a modificar
     IF cx <> 1 THEN
        IF cx = 0 THEN R(i, 1) = 1E+20 ELSE R(i, 1) = R(i, 1) + cx
     END IF
     IF cz <> 1 THEN
        IF cz = 0 THEN R(j, 1) = 1E+20 ELSE R(j, 1) = R(j, 1) + cz
     END IF
  NEXT iap: er$ = "DEFINICION APOYOS": GOSUB Fin.Grupo: CLOSE #1
  RETURN


Graba.Resul:                           '*** Clculo y grabacin de resultados
  PRINT : PRINT "GRABANDO RESULTADOS"
  d$ = " Nudo   Direc. x    Direc. z       "
  c$ = "#### #####.##### #####.#####       "
  a$ = "   i     j     Axil       "
  b$ = "####  #### #####.###      "
  FOR ih = 1 TO Nhi
    PRINT #2, : PRINT #2, : PRINT #2, TAB(10); tit$
    PRINT #2, : PRINT #2, TAB(30); "HIPOTESIS NUM."; ih
    PRINT #2, : PRINT #2, TAB(26); "DESPLAZAMIENTOS DE NUDOS"
    PRINT #2, : PRINT #2, d$; d$
    PRINT #2, : i = 1
    FOR inu = 1 TO Nnu
      PRINT #2, USING c$; inu, F(i, ih), F(i + 1, ih);
      IF (inu \ 2) * 2 = inu THEN PRINT #2,
      i = i + 2
    NEXT inu
    PRINT #2, : PRINT #2,
    PRINT #2, TAB(29); "ESFUERZOS EN BARRAS": PRINT #2,
    PRINT #2, a$; a$; a$: PRINT #2,
    FOR iba = 1 TO Nba
        i = ni(iba): j = nj(iba): ntip = it(iba)
        ifi = 2 * (i - 1) + 1: jfi = 2 * (j - 1) + 1  '*** Filas nudos i y j
        dx = x(j) - x(i):  dz = z(j) - z(i)
        rl = SQR(dx * dx + dz * dz)
        cosa = dx / rl: cosb = dz / rl
        EAL = E * Area(ntip) / rl                    '*** Coefs. de rigidez
        x = F(jfi, ih) - F(ifi, ih)
        z = F(jfi + 1, ih) - F(ifi + 1, ih)
        ax = (x * cosa + z * cosb) * EAL
        PRINT #2, USING b$; i, j, ax;
        IF (iba \ 3) * 3 = iba THEN PRINT #2,
    NEXT iba
  NEXT ih
  RETURN



                                                                          
                                                             




