'*** Programa AM3 - Estruc. Articul. Espacial - Cargas nudos- QuickBASIC 4.0 *
'*** Autor:  Francisco Morn Cabr - Avenida de Amrica, 51 - 28.002  Madrid *


DEFINT I-N: OPTION BASE 1
OPEN "DATOS" FOR INPUT AS #1
OPEN "RES" FOR OUTPUT AS #2

Herc% = 0                  '*** Pantalla CGA. Para Hrcules, poner Herc% = 1
IF Herc% = 1 THEN npixx = 719: npixz = 347: ncarx = 9: ncarz = 14: rel = 1.5
IF Herc% = 0 THEN npixx = 639: npixz = 199: ncarx = 8: ncarz = 8: rel = 2.4

GOSUB Dat.Grales
GOSUB Abscisas
GOSUB Ordenadas
GOSUB Cotas
GOSUB Barras.Tipo
GOSUB Escalas
GOSUB Mat.Rigidez
GOSUB Numer.Nudos
GOSUB Carg.Nudos
GOSUB Apoyos
'GOSUB Print.Matriz
GOSUB Okey
GOSUB Sol.Sistema
GOSUB Graba.Resul

SCREEN 0: END


Dat.Grales:                           '*** Lectura del ttulo, datos grales
  INPUT #1, tit$                      '*** y dimensionamiento de las matrices
  er$ = "TITULO": GOSUB Fin.Grupo
  INPUT #1, Nnu, Nba, Ndi, Nhi, E  '*** Nm.Nudos, barr, difmax, hipt, Young
  er$ = "DATOS GRALES": GOSUB Fin.Grupo
  Nec = 3 * Nnu: Nsb = 3 * (Ndi + 1)       '*** Nm. ecuac. y ancho semibanda
  DIM x(Nnu), y(Nnu), z(Nnu), ni(Nba), nj(Nba), it(Nba)'** Coord, incidencias
  DIM R(Nec, Nsb), F(Nec, Nhi)             '*** Matrices de Rigidez y Cargas
  RETURN


Mat.Rigidez:                     '*** Lectura de datos barras, comprobacin,
  FOR iba = 1 TO Nba             '*** dibujo croquis y formac.matriz rigidez
    INPUT #1, i, j, ntip               '*** Incidencia y tipo de la barra
    IF ntip > Nbt OR i > Nnu OR j > Nnu OR i >= j OR j - i > Ndi THEN
       er$ = "BARRA " + STR$ (i) + " - " + STR$ (j): GOSUB Mensaje: END
    END IF

    xi = (x(i) - xmin) * esx: zi = npixz - (z(i) - zmin) * esz
    xj = (x(j) - xmin) * esx: zj = npixz - (z(j) - zmin) * esz
    LINE (xi, zi)-(xj, zj)

    ni(iba) = i: nj(iba) = j: it(iba) = ntip
    i1 = 3 * (i - 1) + 1: i2 = i1 + 1: i3 = i2 + 1      '*Filas modif.nudo i
    j1 = 3 * (j - 1) + 1: j2 = j1 + 1: j3 = j2 + 1      '*Filas modif.nudo j
    jd = 3 * (j - i)                                    '*Distancia i - j
    dx = x(j) - x(i): dy = y(j) - y(i): dz = z(j) - z(i)
    rl = SQR(dx * dx + dy * dy + dz * dz)               '*Longitud barra
    cosa = dx / rl: cosb = dy / rl: cosc = dz / rl      '*Cosenos directores
    EAL = E * Area(ntip) / rl                       '*** Elto. para clculo
    t = EAL * cosa * cosa                           '*** de la matriz rigidez
    R(i1, 1) = R(i1, 1) + t: R(j1, 1) = R(j1, 1) + t   '*** Aportacin de la
    R(i1, 1 + jd) = -t                                 '*** barra a la matriz
    t = EAL * cosa * cosb                              '*** de rigidez
    R(i1, 2) = R(i1, 2) + t: R(j1, 2) = R(j1, 2) + t
    R(i1, 2 + jd) = -t: R(i2, jd) = -t
    t = EAL * cosa * cosc
    R(i1, 3) = R(i1, 3) + t: R(j1, 3) = R(j1, 3) + t
    R(i1, 3 + jd) = -t: R(i3, -1 + jd) = -t
    t = EAL * cosb * cosb
    R(i2, 1) = R(i2, 1) + t: R(j2, 1) = R(j2, 1) + t
    R(i2, 1 + jd) = -t
    t = EAL * cosb * cosc
    R(i2, 2) = R(i2, 2) + t: R(j2, 2) = R(j2, 2) + t
    R(i2, 2 + jd) = -t: R(i3, jd) = -t
    t = EAL * cosc * cosc
    R(i3, 1) = R(i3, 1) + t: R(j3, 1) = R(j3, 1) + t
    R(i3, 1 + jd) = -t
  NEXT iba: er$ = "DEF. DE BARRAS": GOSUB Fin.Grupo
  RETURN


Carg.Nudos:                            '*** Lectura cargas nudos y formacin
  FOR ih = 1 TO Nhi                    '*** de trminos independientes
      INPUT #1, Nnc                     '*** Nm. de nudos con cargas
      FOR inu = 1 TO Nnc
          INPUT #1, nn, Fx, Fy, Fz      '*** Nudo cargado, componentes carga
          i = 3 * (nn - 1) + 1
          F(i, ih) = Fx
          F(i + 1, ih) = Fy
          F(i + 2, ih) = Fz
      NEXT inu
  NEXT ih: er$ = "CARGAS EN NUDOS": GOSUB Fin.Grupo
  RETURN


Graba.Resul:                           '*** Clculo y grabacin de resultados
  PRINT : PRINT "GRABANDO RESULTADOS"
  c$ = "#### #####.##### #####.##### #####.#####"
  a$ = "   i     j     Axil       "
  b$ = "####  ####": d$ = "######.###      "
  FOR ih = 1 TO Nhi
    PRINT #2, : PRINT #2, : PRINT #2, TAB(10); tit$
    PRINT #2, : PRINT #2, TAB(20); "HIPOTESIS NUM."; ih
    PRINT #2, : PRINT #2, TAB(16); "DESPLAZAMIENTOS DE NUDOS"
    PRINT #2, : PRINT #2, " Nudo   Direc. x    Direc. y    Direc. z"
    PRINT #2, : i = 1
    FOR inu = 1 TO Nnu
      PRINT #2, USING c$; inu, F(i, ih), F(i + 1, ih), F(i + 2, ih)
      i = i + 3
    NEXT inu
    PRINT #2, : PRINT #2,
    PRINT #2, TAB(29); "ESFUERZOS EN BARRAS": PRINT #2,
    PRINT #2, a$; a$; a$: PRINT #2,
    FOR iba = 1 TO Nba
        i = ni(iba): j = nj(iba): ntip = it(iba)
        ifi = 3 * (i - 1) + 1: jfi = 3 * (j - 1) + 1  '*** Filas nudos i y j
        dx = x(j) - x(i): dy = y(j) - y(i): dz = z(j) - z(i)
        rl = SQR(dx * dx + dy * dy + dz * dz)
        cosa = dx / rl: cosb = dy / rl: cosc = dz / rl
        EAL = E * Area(ntip) / rl                    '*** Coefs. de rigidez
        x = F(jfi, ih) - F(ifi, ih)
        y = F(jfi + 1, ih) - F(ifi + 1, ih)
        z = F(jfi + 2, ih) - F(ifi + 2, ih)
        ax = (x * cosa + y * cosb + z * cosc) * EAL
        PRINT #2, USING b$; i, j;
        PRINT #2, USING d$; ax;
        IF (iba \ 3) * 3 = iba THEN PRINT #2,
    NEXT iba
  NEXT ih
  RETURN









